using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;

namespace Ruvik
{
    public class PHUI
    {
        public static GameObject phGameObject = null;
        static Sprite PHButtonSprite = null;
        static List<string> controlableAtomsNames = null;
        static Text controlledAtomNameTextUI = null;
        private static int currentNameIndex = 0;
        static public bool isLocalToggled = true;
        static public void InitPH()
        {
            if(GameObject.Find("posing helper canvas")!=null)
            {
                SuperController.LogError("please make sure there's only one instance of this plugin in the scene");
                return;
            }
            PHButtonSprite = GameObject.Find("MainWindowUI").GetComponentInChildren<Image>().sprite;
            phGameObject = new GameObject("posing helper canvas");
            var phCanvas = phGameObject.AddComponent<Canvas>();
            phCanvas.renderMode = RenderMode.ScreenSpaceOverlay;
            phGameObject.AddComponent<CanvasScaler>().uiScaleMode = CanvasScaler.ScaleMode.ScaleWithScreenSize;
            phGameObject.AddComponent<GraphicRaycaster>();
            phGameObject.GetComponent<CanvasScaler>().screenMatchMode = CanvasScaler.ScreenMatchMode.Expand;
            InitPHMenu();
            CreateMenus();
            CreateButtons();

            controlledAtomNameTextUI = GetPHButton("name").GetComponentInChildren<Text>();
            controlledAtomNameTextUI.text = "None";
            GetPHButton("next").onClick.AddListener(delegate () { SelectAtom(true); });
            GetPHButton("prev").onClick.AddListener(delegate () { SelectAtom(false); });
			GetPHButton("PX").gameObject.AddComponent<MovementButtons>();
			GetPHButton("PY").gameObject.AddComponent<MovementButtons>();
			GetPHButton("PZ").gameObject.AddComponent<MovementButtons>();
			GetPHButton("RX").gameObject.AddComponent<MovementButtons>();
			GetPHButton("RY").gameObject.AddComponent<MovementButtons>();
			GetPHButton("RZ").gameObject.AddComponent<MovementButtons>();
			GetPHButton("State").onClick.AddListener(LocalButtonAction());
			GetPHButton("Focus").onClick.AddListener(FocusButtonAction());
			GetPHButton("Symmetry").onClick.AddListener(SymmetryButtonAction());
            GetPHButton("Reset_Link").onClick.AddListener(PHUtils.ResetLink());
            GetPHButton("Reset_Pose").onClick.AddListener(PHUtils.ResetPose());
            GetPHButton("Link").onClick.AddListener(PHUtils.LinkAll());
            GetPHButton("Set_Link").onClick.AddListener(PHUtils.SetLink());
            GetPHButton("Clear_Link").onClick.AddListener(PHUtils.ClearLink());
            GetPHButton("refresh").onClick.AddListener(delegate() { RefreshAtoms(); });
            GetPHButton("MRA").onClick.AddListener(PHUtils.MirrorArmsAction(false));
            GetPHButton("MLA").onClick.AddListener(PHUtils.MirrorArmsAction(true));
            GetPHButton("MRL").onClick.AddListener(PHUtils.MirrorLegsAction(false));
            GetPHButton("MLL").onClick.AddListener(PHUtils.MirrorLegsAction(true));
            GetPHButton("SA").onClick.AddListener(PHUtils.SwapArms());
            GetPHButton("SL").onClick.AddListener(PHUtils.SwapLegs());
            GetPHButton("Lock").GetComponentInChildren<Text>().fontSize = 7;
            GetPHButton("Comply").GetComponentInChildren<Text>().fontSize = 7;
            GetPHButton("On").GetComponentInChildren<Text>().fontSize = 7;
            GetPHButton("Off").GetComponentInChildren<Text>().fontSize = 7;
            GetPHButton("Parlink").GetComponentInChildren<Text>().fontSize = 7;
            GetPHButton("Phylink").GetComponentInChildren<Text>().fontSize = 7;
            GetPHButton("Lock").onClick.AddListener(PHUtils.SetControllersState(FreeControllerV3.PositionState.Lock,FreeControllerV3.RotationState.Lock));
            GetPHButton("Comply").onClick.AddListener(PHUtils.SetControllersState(FreeControllerV3.PositionState.Comply,FreeControllerV3.RotationState.Comply));
            GetPHButton("On").onClick.AddListener(PHUtils.SetControllersState(FreeControllerV3.PositionState.On,FreeControllerV3.RotationState.On));
            GetPHButton("Off").onClick.AddListener(PHUtils.SetControllersState(FreeControllerV3.PositionState.Off,FreeControllerV3.RotationState.Off));
            GetPHButton("Parlink").onClick.AddListener(PHUtils.SetControllersState(FreeControllerV3.PositionState.ParentLink,FreeControllerV3.RotationState.ParentLink));
            GetPHButton("Phylink").onClick.AddListener(PHUtils.SetControllersState(FreeControllerV3.PositionState.PhysicsLink,FreeControllerV3.RotationState.PhysicsLink));
            SuperController.singleton.AddCanvas(phCanvas);
            phGameObject.SetActive(false);
        }

        static public UnityAction FocusButtonAction()
        {
            return delegate ()
            {
                PHUtils.FocusButtonMethod();
            };
        }
        static public UnityAction LocalButtonAction()
        {
            return delegate
            {
                PHUtils.SwitchMovementMode();
            };
        }

        static public UnityAction SymmetryButtonAction()
        {
            return delegate
            {
                PHUtils.ToggleSymmetry();
            };
        }
        static public Button GetPHButton(string name)
        {
            GameObject phButtonGo = GameObject.Find("PH_" + name);

            if (phButtonGo == null)
                SuperController.LogError("wrong button name");
            else
                return phButtonGo.GetComponent<Button>();

            return null;
        }
        static public void RefreshAtoms()
        {
            if (controlableAtomsNames != null)
                controlableAtomsNames.Clear();
            else
                controlableAtomsNames = new List<string>();


            foreach(var atom in SuperController.singleton.GetAtoms())
            {
                // the way used to check if atom is human is fucky
                if (atom.mainController != null && atom.freeControllers.Length > 20)
                    controlableAtomsNames.Add(atom.uid);
            }

            if (!phGameObject.activeInHierarchy)
                phGameObject.SetActive(true);

            SelectAtom(true);
        }
        static private void SelectAtom(bool next)
        {
            PHUndo.ClearCache(); 
            if (controlableAtomsNames.Count == 0)
                return;
            else if(controlableAtomsNames.Count == 1 )
                SelectAtom(controlableAtomsNames.First());

            string atomName;

            if (next)
                currentNameIndex = currentNameIndex == controlableAtomsNames.Count -1 ? 0 : currentNameIndex + 1;
            else
                currentNameIndex = currentNameIndex == 0 ? controlableAtomsNames.Count -1 : currentNameIndex - 1;

            atomName = controlableAtomsNames.ElementAt(currentNameIndex);
            if (atomName != null)
            SelectAtom(atomName);
        }
        static private void SelectAtom(string atomName)
        {
            controlledAtomNameTextUI.text = atomName;
            PHUtils.InitPHControllers(SuperController.singleton.GetAtomByUid(atomName));
        }
        static public void PHMenuDesroy()
        {
            if (phGameObject != null)
                GameObject.Destroy(phGameObject);
        }
        static public void PHMenuSetActive(bool state)
        {
            if (phGameObject != null)
                phGameObject.SetActive(state);
        }
        static private void InitPHMenu()
        {
            foreach (var item in UIRectSpecs)
            {
                GameObject go = new GameObject(GetName(item));

                GameObject root = GameObject.Find(GetParent(item));
                go.transform.SetParent(root.transform);

                var rootRect = go.AddComponent<RectTransform>();
                SetRect(ref rootRect, GetData(item));
            }
        }
        static private void CreateButtons()
        {
            foreach (var item in UIButtonSpecs)
            {
                GameObject go = GameObject.Find(GetName(item));
                go.AddComponent<Button>();
                var img = go.GetComponent<Image>();
                img.sprite = PHButtonSprite;
                img.type = Image.Type.Sliced;
                img.type = Image.Type.Sliced;
                GameObject textGo = new GameObject("PH_text");
                textGo.transform.SetParent(go.transform);
                var textRect = textGo.AddComponent<RectTransform>();
                var text = textGo.AddComponent<Text>();
                SetRect(ref textRect, UITextRectSpecs);
                text.text = GetData(item);
                text.fontSize = 10;
                text.fontStyle = FontStyle.Normal;
                text.color = Color.black;
                text.alignment = TextAnchor.MiddleCenter;
                text.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            }
        }
        static private void CreateMenus()
        {
            foreach (var item in UIImgSpecs)
            {
                var rootImage = GameObject.Find(GetName(item)).AddComponent<Image>();
                rootImage.color = GenColor(GetData(item));
            }
        }

        static private string[] UIRectSpecs = new string[]
        {
        "posing helper canvas/PH_menu:-10,80,1,0,150,230,1,0,1,0,-160,80,-10,310",
        "PH_menu/PH_bones:0,10,0.5,0.5,0,-20,0,0,1,1,0,20,0,0",
        "PH_bones/PH_head:0,88,0.5,0.5,30,20,0.5,0.5,0.5,0.5,-15,82,15,102",
        "PH_bones/PH_neck:0,72,0.5,0.5,30,20,0.5,0.5,0.5,0.5,-15,62,15,82",
        "PH_bones/PH_R.shoulder:40,72,0.5,0.5,50,20,0.5,0.5,0.5,0.5,15,62,65,82",
        "PH_bones/PH_L.shoulder:-40,72,0.5,0.5,50,20,0.5,0.5,0.5,0.5,-65,62,-15,82",
        "PH_bones/PH_L.elbow:-50,50,0.5,0.5,40,20,0.5,0.5,0.5,0.5,-70,40,-30,60",
        "PH_bones/PH_R.elbow:50,50,0.5,0.5,40,20,0.5,0.5,0.5,0.5,30,40,70,60",
        "PH_bones/PH_L.hand:-55,25,0.5,0.5,40,20,0.5,0.5,0.5,0.5,-75,15,-35,35",
        "PH_bones/PH_R.hand:55,25,0.5,0.5,40,20,0.5,0.5,0.5,0.5,35,15,75,35",
        "PH_bones/PH_chest:0,50,0.5,0.5,60,20,0.5,0.5,0.5,0.5,-30,40,30,60",
        "PH_bones/PH_waist:0,27,0.5,0.5,60,20,0.5,0.5,0.5,0.5,-30,17,30,37",
        "PH_bones/PH_pelvis:0,5,0.5,0.5,60,20,0.5,0.5,0.5,0.5,-30,-5,30,15",
        "PH_bones/PH_hip:0,-18,0.5,0.5,60,20,0.5,0.5,0.5,0.5,-30,-28,30,-8",
        "PH_bones/PH_L.thigh:-30,-40,0.5,0.5,60,20,0.5,0.5,0.5,0.5,-60,-50,0,-30",
        "PH_bones/PH_R.thigh:30,-40,0.5,0.5,60,20,0.5,0.5,0.5,0.5,0,-50,60,-30",
        "PH_bones/PH_L.knee:-35,-65,0.5,0.5,60,20,0.5,0.5,0.5,0.5,-65,-75,-5,-55",
        "PH_bones/PH_R.knee:35,-65,0.5,0.5,60,20,0.5,0.5,0.5,0.5,5,-75,65,-55",
        "PH_bones/PH_L.foot:-45,-90,0.5,0.5,60,20,0.5,0.5,0.5,0.5,-75,-100,-15,-80",
        "PH_bones/PH_R.foot:45,-90,0.5,0.5,60,20,0.5,0.5,0.5,0.5,15,-100,75,-80",
        "PH_bones/PH_refresh:-45,-90,0.5,0.5,60,20,0.5,0.5,0.5,0.5,-17,-100,17,-80",
        "PH_bones/PH_Lock:-60,95.48,0.5,0.5,20,20,0.5,0.5,0.5,0.5,-75,85.48,-55,105.48",
        "PH_bones/PH_Comply:-60,95.48,0.5,0.5,20,20,0.5,0.5,0.5,0.5,-55,85.48,-35,105.48",
        "PH_bones/PH_Phylink:-60,95.48,0.5,0.5,20,20,0.5,0.5,0.5,0.5,-35,85.48,-15,105.48",
        "PH_bones/PH_Off:26,95.48,0.5,0.5,20,20,0.5,0.5,0.5,0.5,16,85.48,36,105.48",
        "PH_bones/PH_On:46,95.48,0.5,0.5,20,20,0.5,0.5,0.5,0.5,36,85.48,56,105.48",
        "PH_bones/PH_Parlink:66,95.48,0.5,0.5,20,20,0.5,0.5,0.5,0.5,56,85.48,76,105.48",
        "PH_menu/PH_select:0,-105,0.5,0.5,0,-210,0,0,1,1,0,0,0,-210",
        "PH_select/PH_prev:5,0,0,0.5,20,0,0,0,0,1,5,0,25,0",
        "PH_select/PH_name:0,0,0.5,0.5,90,0,0.5,0,0.5,1,-45,0,45,0",
        "PH_select/PH_next:-5,0,1,0.5,20,0,1,0,1,1,-24,0,-5,1",
        "posing helper canvas/PH_movement:-10,10,1,0,150,70,1,0,1,0,-160,10,-10,80",
        "PH_movement/PH_PZ:6.103516E-05,0,1,1,50,36,1,1,1,1,-49.99994,-36,6.103516E-05,0",
        "PH_movement/PH_PY:6.103516E-05,0,0.5,1,50,36,0.5,1,0.5,1,-24.99994,-36,25.00006,0",
        "PH_movement/PH_PX:6.103516E-05,0,0,1,50,36,0,1,0,1,6.103516E-05,-36,50.00006,0",
        "PH_movement/PH_RZ:6.103516E-05,0,1,0,50,36,1,0,1,0,-49.99994,0,6.103516E-05,36",
        "PH_movement/PH_RY:6.103516E-05,0,0.5,0,50,36,0.5,0,0.5,0,-24.99994,0,25.00006,36",
        "PH_movement/PH_RX:6.103516E-05,0,0,0,50,36,0,0,0,0,6.103516E-05,0,50.00006,36",
        "posing helper canvas/PH_functions:-160,10,1,0,80,300,1,0,1,0,-240,10,-160,310",
        "PH_bones/PH_Focus:-55,25,0.5,0.5,40,20,0.5,0.5,0.5,0.5,-75,-15,-35,05",
        "PH_functions/PH_MRA:0,0,0.5,1,0,25.52547,0,1,1,1,0,-25.52547,0,0",
        "PH_functions/PH_MLA:0,-25.89,0.5,1,0,25.52547,0,1,1,1,0,-51.41547,0,-25.89",
        "PH_functions/PH_MRL:0,-55.66002,0.5,1,0,25.52547,0,1,1,1,0,-81.18549,0,-55.66002",
        "PH_functions/PH_MLL:0,-81.55,0.5,1,0,25.52547,0,1,1,1,0,-107.0755,0,-81.55",
        "PH_functions/PH_SA:0,-111.33,0.5,1,0,25.52547,0,1,1,1,0,-136.8555,0,-111.33",
        "PH_functions/PH_SL:0,-137.21,0.5,1,0,25.52547,0,1,1,1,0,-162.7355,0,-137.21",
        "PH_functions/PH_Symmetry:0,-160.19,0.5,1,0,22,0,1,1,1,0,-182.19,0,-160.19",
        "PH_functions/PH_State:0,-180.19,0.5,1,0,22,0,1,1,1,0,-202.19,0,-180.19",
        "PH_functions/PH_Set_Link:0,-202.19,0.5,1,0,22,0,1,1,1,0,-224.19,0,-202.19",
        "PH_functions/PH_Clear_Link:0,-224.19,0.5,1,0,22,0,1,1,1,0,-246.19,0,-224.19",
        "PH_functions/PH_Link:0,-245.39,0.5,1,0,22,0,1,1,1,0,-267.39,0,-245.39",
        "PH_functions/PH_Reset_Link:0,-267.39,0.5,1,0,16,0,1,1,1,0,-283.39,0,-267.39",
        "PH_functions/PH_Reset_Pose:0,-283.39,0.5,1,0,16,0,1,1,1,0,-299.39,0,-283.39",
        };
        static private string[] UIImgSpecs = new string[]
        {
        "PH_menu:0.2,0.3,0.4,0.0",
        "PH_bones:0.2,0.3,0.4,0.3",
        "PH_head:1,1,1,1",
        "PH_neck:1,1,1,1",
        "PH_R.shoulder:1,1,1,1",
        "PH_L.shoulder:1,1,1,1",
        "PH_L.elbow:1,1,1,1",
        "PH_R.elbow:1,1,1,1",
        "PH_L.hand:1,1,1,1",
        "PH_R.hand:1,1,1,1",
        "PH_chest:1,1,1,1",
        "PH_waist:1,1,1,1",
        "PH_pelvis:1,1,1,1",
        "PH_hip:1,1,1,1",
        "PH_L.thigh:1,1,1,1",
        "PH_R.thigh:1,1,1,1",
        "PH_L.knee:1,1,1,1",
        "PH_R.knee:1,1,1,1",
        "PH_L.foot:1,1,1,1",
        "PH_refresh:1,1,1,1",
        "PH_R.foot:1,1,1,1",
        "PH_Lock:1,1,1,1",
        "PH_Comply:1,1,1,1",
        "PH_On:1,1,1,1",
        "PH_Off:1,1,1,1",
        "PH_Parlink:1,1,1,1",
        "PH_Phylink:1,1,1,1",
        "PH_select:0.2,0.3,0.4,0.3",
        "PH_prev:1,1,1,1",
        "PH_name:1,1,1,1",
        "PH_next:1,1,1,1",
        "PH_movement:0.2,0.3,0.4,0.3",
        "PH_PZ:0,0,1,1",
        "PH_PY:0,1,0,1",
        "PH_PX:1,0,0,1",
        "PH_RZ:0,0.5,1,1",
        "PH_RY:0.5,1,0,1",
        "PH_RX:1,0,0.5,1",
        "PH_functions:0.2,0.3,0.4,0.3",
        "PH_MRA:1,1,1,1",
        "PH_MLA:1,1,1,1",
        "PH_MRL:1,1,1,1",
        "PH_MLL:1,1,1,1",
        "PH_SA:1,1,1,1",
        "PH_SL:1,1,1,1",
        "PH_Focus:1,1,1,1",
        "PH_Symmetry:1,1,1,1",
        "PH_State:1,1,1,1",
        "PH_Set_Link:1,1,1,1",
        "PH_Clear_Link:1,1,1,1",
        "PH_Link:1,1,1,1",
        "PH_Reset_Link:1,1,1,1",
        "PH_Reset_Pose:1,1,1,1",
        };
        static private string[] UIButtonSpecs = new string[]
        {
        "PH_head:head",
        "PH_neck:neck",
        "PH_R.shoulder:R.shoulder",
        "PH_L.shoulder:L.shoulder",
        "PH_L.elbow:L.elbow",
        "PH_R.elbow:R.elbow",
        "PH_L.hand:L.hand",
        "PH_R.hand:R.hand",
        "PH_chest:chest",
        "PH_waist:abdomen2",
        "PH_pelvis:hip",
        "PH_hip:abdomen1",
        "PH_L.thigh:L.thigh",
        "PH_R.thigh:R.thigh",
        "PH_L.knee:L.knee",
        "PH_R.knee:R.knee",
        "PH_L.foot:L.foot",
        "PH_R.foot:R.foot",
        "PH_refresh:refresh",
        "PH_Lock:lock",
        "PH_Comply:compl",
        "PH_On:on",
        "PH_Off:off",
        "PH_Parlink:parL",
        "PH_Phylink:phyL",
        "PH_prev:<<",
        "PH_name:Button",
        "PH_next:>>",
        "PH_PZ:Z",
        "PH_Focus:focus",
        "PH_PY:Y",
        "PH_PX:X",
        "PH_RZ:<-Z->",
        "PH_RY:<-Y->",
        "PH_RX:<-X->",
        "PH_MRA:Copy L.Arm",
        "PH_MLA:Copy R.Arm",
        "PH_MRL:Copy L.Leg",
        "PH_MLL:Copy R.Leg",
        "PH_SA:Swap Arms",
        "PH_SL:Swap Legs",
        "PH_Symmetry:Symmetry",
        "PH_State:Local",
        "PH_Link:IK Link",
        "PH_Set_Link:Set Link",
        "PH_Clear_Link:Clear Link",
        "PH_Reset_Link:Reset Link",
        "PH_Reset_Pose:Reset Pose",
        };
        static private string UITextRectSpecs = "0,0,0.5,0.5,0,0,0,0,1,1,0,0,0,0";
        static Color GenColor(string specs)
        {
            float[] fArray = GetArrayFromString(specs);
            return new Color(fArray[0], fArray[1], fArray[2], fArray[3]);
        }
        static private void SetRect(ref RectTransform rt, string specs)
        {
            float[] fArray = GetArrayFromString(specs);
            rt.anchoredPosition3D = new Vector3(fArray[0], fArray[1], 0);
            rt.pivot = new Vector2(fArray[2], fArray[3]);
            rt.sizeDelta = new Vector2(fArray[4], fArray[5]);
            rt.anchorMin = new Vector2(fArray[6], fArray[7]);
            rt.anchorMax = new Vector2(fArray[8], fArray[9]);
            rt.offsetMin = new Vector2(fArray[10], fArray[11]);
            rt.offsetMax = new Vector2(fArray[12], fArray[13]);
            rt.localEulerAngles = Vector3.zero;
            rt.localScale = Vector3.one;
        }
        static private float[] GetArrayFromString(string str)
        {
            return Array.ConvertAll(str.Split(','), float.Parse);
        }

        static private string GetName(string specs)
        {
            string name = "";
            int i;
            if (specs.Contains("/"))
                i = specs.IndexOf('/') + 1;
            else
                i = 0;

            for (; i < specs.Length; i++)
            {
                if (specs[i] == ':')
                    break;
                name += specs[i];
            }
            return name;
        }
        static private string GetParent(string specs)
        {
            string name = "";
            for (int i = 0; i < specs.Length; i++)
            {
                if (specs[i] == '/')
                    break;
                name += specs[i];
            }
            return name;
        }
        static private string GetData(string specs)
        {
            return specs.Substring(specs.IndexOf(':') + 1);
        }
    }
}